###################################################
### chunk number 1: preliminaries
###################################################
#line 66 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
library("gsubfn")
library("proto")


###################################################
### chunk number 2: gsubfn-xypair
###################################################
#line 248 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
   s <- 'abc 10:20 def 30:40 50'
   gsubfn('([0-9]+):([0-9]+)', ~ as.numeric(x) + as.numeric(y), s)


###################################################
### chunk number 3: gsubfn-si
###################################################
#line 253 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
   dat <- c('3.5G', '88P', '19') # test data
   gsubfn('[MGP]$', ~ c(M = 'e6', G = 'e9', P = 'e12')[[x]], dat) 


###################################################
### chunk number 4: gsubfn-si
###################################################
#line 273 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
   dat <- c('3.5G', '88P', '19') # test data
   gsubfn('[MGP]$', list(M = 'e6', G = 'e9', P = 'e12'), dat) 


###################################################
### chunk number 5: gsubfn-proto-intro
###################################################
#line 334 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
   p <- proto(fun = function(this, x) paste0(x, "{", count, "}"))
   class(p)
   ls(p)
   with(p, fun)
   s <- c("the dog and the cat are in the house", "x y x")
   gsubfn("\\w+", p, s)
   ls(p)
   p$count


###################################################
### chunk number 6: gsubfn-words
###################################################
#line 369 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
pwords <- proto(
	pre = function(this) { this$words <- list() },
	fun = function(this, x) {
		if (is.null(words[[x]])) this$words[[x]] <- 0
		this$words[[x]] <- words[[x]] + 1
		paste0(x, "{", words[[x]], "}")
	}
)
gsubfn("\\w+", pwords, "the dog and the cat are in the house")
ls(pwords)
dput(pwords$words)


###################################################
### chunk number 7: gsubfn-strapply-initdigits
###################################################
#line 415 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
   s <- c('123abc', '12cd34', '1e23')
   strapply(s, '^([[:digit:]]+)(.*)', c, simplify = rbind)


###################################################
### chunk number 8: gsubfn-strapply-midpoint
###################################################
#line 421 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
rn <- c("[-11.9,-10.6]", "(NA,9.3]", "(9.3,8e01]", "(8.01,Inf]")
colMeans(strapply(rn, "[^][(),]+", as.numeric, simplify = TRUE))


###################################################
### chunk number 9: gsubfn-strapply-combine
###################################################
#line 433 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"

s <- c('a:b c:d', 'e:f')

dput(strapply(s, '(.):(.)', c))

dput(strapply(s, '(.):(.)', c, combine = list))



###################################################
### chunk number 10: gsubfn-strapply-words
###################################################
#line 450 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
pwords2 <- proto(
	pre = function(this) { this$words <- list() },
	fun = function(this, x) {
		if (is.null(words[[x]])) this$words[[x]] <- 0
		this$words[[x]] <- words[[x]] + 1
		list(x, words[[x]])
	}
)
strapply("the dog and the cat are in the house", "\\w+", pwords2, 
	combine = list, simplify = x ~ do.call(rbind, x) )
ls(pwords2)
dput(pwords2$words)


###################################################
### chunk number 11: gsubfn-paste0
###################################################
#line 480 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
strapply(' a b c d e f ', ' [a-z](?=( [a-z] ))', paste0)[[1]]


###################################################
### chunk number 12: gsubfn-fn
###################################################
#line 534 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"

fn$integrate(~ sin(x) + sin(x), 0, pi/2)

fn$lapply(list(1:4, 1:5), ~ LETTERS[x])

fn$mapply(~ seq_len(x) + y * z, 1:3, 4:6, 2) # list(9, 11:12, 13:15)

CO2df <- as.data.frame(CO2)
fn$by(CO2df[4:5], CO2df[2], x ~ coef(lm(uptake ~ ., x)), simplify = rbind)



###################################################
### chunk number 13: gsubfn-fn-lattice eval=FALSE
###################################################
## #line 554 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
## library(lattice)
## library(grid)
## CO2df <- as.data.frame(CO2)
## print(fn$xyplot(uptake ~ conc | Plant, CO2df,
##       panel = ~~ { panel.xyplot(...); grid.text(panel.number(), .1, .85) }))


###################################################
### chunk number 14: gsubfn-fn-lattice-repeat
###################################################
#line 564 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
#line 554 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw#from line#564#"
library(lattice)
library(grid)
CO2df <- as.data.frame(CO2)
print(fn$xyplot(uptake ~ conc | Plant, CO2df,
      panel = ~~ { panel.xyplot(...); grid.text(panel.number(), .1, .85) }))
#line 565 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"


###################################################
### chunk number 15: gsubfn-fn-simplify
###################################################
#line 585 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
CO2df <- as.data.frame(CO2)
fn$by(CO2df, CO2df$Treatment, d ~ coef(lm(uptake ~ conc, d)), simplify = rbind)


###################################################
### chunk number 16: gsubfn-fn-letters
###################################################
#line 596 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
fn$lapply(list(1:4, 1:3), ~ LETTERS[x])


###################################################
### chunk number 17: gsubfn-fn-aggregate-0
###################################################
#line 609 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
CO2df <- as.data.frame(CO2)
fn$aggregate(CO2df[4:5], CO2df[3], ~ mean(range(x)))

library(reshape2)
fn$dcast(Type ~ variable, data = melt(CO2df, id = 1:3), ~~ mean(range(x)))

library(doBy) # need version 0.9 or later
fn$summaryBy(. ~ Treatment, CO2df[3:5], FUN = ~~ c(midrange = mean(range(x))))


###################################################
### chunk number 18: gsubfn-fn-aggregate
###################################################
#line 620 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
fn$aggregate(CO2df[4:5], CO2df[3], ~ mean(range(x)))

library(reshape2)
fn$dcast(Treatment ~ variable, data = melt(CO2df, id = 1:3), ~~ mean(range(x)))

library(doBy) # need version 0.9 or later
CO2df <- as.data.frame(CO2)
fn$summaryBy(. ~ Treatment, CO2df[3:5], FUN = ~~ c(midrange = mean(range(x))))


###################################################
### chunk number 19: gsubfn-fn-aggregate2
###################################################
#line 639 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
set.seed(1)
X <- data.frame(X = rnorm(24), W = runif(24), A = gl(2, 1, 24), B = gl(2, 2, 24))
fn$aggregate(1:nrow(X), X[3:4], i ~ weighted.mean(X[i,1], X[i,2]))



###################################################
### chunk number 20: gsubfn-fn-math
###################################################
#line 649 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
fn$integrate(~1/((x+1)*sqrt(x)), lower = 0, upper = Inf)

fn$optimize(~ x^2, c(-1,1))


###################################################
### chunk number 21: gsubfn-fn-S4
###################################################
#line 668 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
setClass('ooc', representation(a = 'numeric'))
fn$setGeneric('incr', x + value ~ standardGeneric('incr'))
fn$setMethod('incr', 'ooc', x + value ~ {x@a <- x@a+value; x})
oo <- new('ooc', a = 1)
oo <- incr(oo,1)
oo


###################################################
### chunk number 22: gsubfn-fn-quantreg-load
###################################################
#line 684 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
library(quantreg)
data(engel)
plot(engel$income, engel$foodexp, xlab = 'income', ylab = 'food expenditure')
junk <- fn$lapply(1:9/10, tau ~ abline(coef(rq(foodexp ~ income, tau, engel))))


###################################################
### chunk number 23: gsubfn-fn-quantreg eval=FALSE
###################################################
## #line 691 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
## plot(engel$income, engel$foodexp, xlab = 'income', ylab = 'food expenditure')
## junk <- fn$lapply(1:9/10, tau ~ abline(coef(rq(foodexp ~ income, tau, engel))))


###################################################
### chunk number 24: gsubfn-fn-quantreg-repeat
###################################################
#line 699 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
#line 691 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw#from line#699#"
plot(engel$income, engel$foodexp, xlab = 'income', ylab = 'food expenditure')
junk <- fn$lapply(1:9/10, tau ~ abline(coef(rq(foodexp ~ income, tau, engel))))
#line 700 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"


###################################################
### chunk number 25: gsubfn-fn-zoo
###################################################
#line 716 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
library(zoo)
fn$rollapply(LakeHuron, 12, ~ mean(range(x)))


###################################################
### chunk number 26: gsubfn-fn-zoo
###################################################
#line 728 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
library(boot)
set.seed(1)
fn$boot(rivers, ~ median(x[d]), R = 2000)


###################################################
### chunk number 27: gsubfn-fn-pi eval=FALSE
###################################################
## #line 737 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
## x <- 0:50/50
## matplot(x, fn$outer(x, 1:8, ~ sin(x * k*pi)), type = 'blobcsSh')


###################################################
### chunk number 28: gsubfn-fn-pi-repeat
###################################################
#line 744 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
#line 737 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw#from line#744#"
x <- 0:50/50
matplot(x, fn$outer(x, 1:8, ~ sin(x * k*pi)), type = 'blobcsSh')
#line 745 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"


###################################################
### chunk number 29: gsubfn-fn-matmult
###################################################
#line 762 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
a <- matrix(4:1, 2); b <- matrix(1:4, 2) # test matrices
fn$apply(b, 2, x ~ fn$apply(a, 1, y ~ sum(x*y)))
a %*% b 


###################################################
### chunk number 30: gsubfn-fn-subseq
###################################################
#line 771 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
L <- fn$apply(fn$sapply(1:4, ~ rbind(i,i:4), simplify = cbind), 2, ~ x[1]:x[2])
dput(L)


###################################################
### chunk number 31: gsubfn-fn-python
###################################################
#line 783 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
fn$sapply( 1:10, ~ if (x%%2==0) x^2, simplify = c)


###################################################
### chunk number 32: gsubfn-fn-cat
###################################################
#line 788 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
fn$cat("pi = $pi, exp = `exp(1)`\n")


###################################################
### chunk number 33: gsubfn-fn-sq
###################################################
#line 807 "d:/Rcompile/CRANpkg/local/2.12/gsubfn/inst/doc/gsubfn.Rnw"
sq <- function(f, x) { f <- match.funfn(f); f(x^2) }

sq(~ exp(x)/x, pi)

f <- function(x) exp(x)/x
sq('f', pi) # character string

f <- function(x) exp(x)/x
sq(f, pi)
 
sq(function(x) exp(x)/x, pi)


